diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java
index 61f5cfd7c..4d1eb51a5 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.world.generate.feature.tree;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
-import net.minecraft.core.world.season.Seasons;
 
 import java.util.Random;
 
@@ -17,14 +17,14 @@ public class WorldFeatureTreeCherry extends WorldFeatureTree {
 	@Override
 	public void placeLeaves(World world, int x, int y, int z, Random rand) {
 		if(rand.nextInt(5) == 0) {
-			world.setBlockAndMetadataWithNotify(x, y, z, Block.leavesCherryFlowering.id, 0);
+			world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LEAVES_CHERRY_FLOWERING.id, 0);
 		}else {
-			world.setBlockWithNotify(x, y, z, Block.leavesCherry.id);
+			world.setBlockWithNotify(x, y, z, Blocks.LEAVES_CHERRY.id);
 		}
 	}
 	
 	@Override
 	public boolean isLeaf(int id) {
-		return id == Block.leavesCherryFlowering.id || id == Block.leavesCherry.id;
+		return id == Blocks.LEAVES_CHERRY_FLOWERING.id || id == Blocks.LEAVES_CHERRY.id;
 	}
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeEucalyptus.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeEucalyptus.java
index 8e3ed9176..cb42e364f 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeEucalyptus.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeEucalyptus.java
@@ -11,52 +11,68 @@ import java.util.Random;
 
 public class WorldFeatureTreeEucalyptus extends WorldFeature
 {
+    Random random;
+    World world;
+    int[] origin = {
+        0, 0, 0
+    };
+    int height;
+    int trunkHeight;
+    double trunkHeightScale;
+    double branchDensity;
+    double branchSlop;
+    double widthScale;
+    double foliageDensity;
+    int trunkWidth;
+    int heightVariance;
+    int foliageHeight;
+    int foliageCoords[][];
     protected int leavesID;
     protected int logID;
     @MethodParametersAnnotation(names = {"leavesID", "logID"})
     public WorldFeatureTreeEucalyptus(int leavesID, int logID)
     {
-        field_881_b = new Random();
-        field_878_e = 0;
-        field_876_g = 0.381D;
-        field_875_h = 1.0D;
-        field_874_i = 0.381D;
-        field_873_j = 1.0D;
-        field_872_k = 1.0D;
-        field_871_l = 1;
-        field_870_m = 20;
-        field_869_n = 10;
+        random = new Random();
+        height = 0;
+        trunkHeightScale = 0.381D;
+        branchDensity = 1.0D;
+        branchSlop = 0.381D;
+        widthScale = 1.0D;
+        foliageDensity = 1.0D;
+        trunkWidth = 1;
+        heightVariance = 20;
+        foliageHeight = 10;
         this.leavesID = leavesID;
         this.logID = logID;
     }
 
-    void func_521_a()
+    void prepare()
     {
-        height = (int)((double)field_878_e * field_876_g);
-        if(height >= field_878_e)
+        trunkHeight = (int)((double) height * trunkHeightScale);
+        if(trunkHeight >= height)
         {
-            height = field_878_e - 1;
+            trunkHeight = height - 1;
         }
-        int i = (int)(1.381D + java.lang.Math.pow((field_872_k * (double)field_878_e) / 7D, 2D));
+        int i = (int)(1.381D + Math.pow((foliageDensity * (double) height) / 7D, 2D));
         if(i < 1)
         {
             i = 1;
         }
-        int ai[][] = new int[i * field_878_e][4];
-        int j = (basePos[1] + field_878_e) - field_869_n;
+        int[][] ai = new int[i * height][4];
+        int j = (origin[1] + height) - foliageHeight;
         int k = 1;
-        int l = basePos[1] + height;
-        int i1 = j - basePos[1];
-        ai[0][0] = basePos[0];
+        int l = origin[1] + trunkHeight;
+        int i1 = j - origin[1];
+        ai[0][0] = origin[0];
         ai[0][1] = j;
-        ai[0][2] = basePos[2];
+        ai[0][2] = origin[2];
         ai[0][3] = l;
         j--;
         while(i1 >= 0)
         {
             int j1 = 0;
-            float f = func_528_a(i1);
-            if(f < 0.0F)
+            float treeShape = treeShape(i1);
+            if(treeShape < 0.0F)
             {
                 j--;
                 i1--;
@@ -65,25 +81,25 @@ public class WorldFeatureTreeEucalyptus extends WorldFeature
                 double d = 0.5D;
                 for(; j1 < i; j1++)
                 {
-                    double d1 = field_873_j * ((double)f * ((double)field_881_b.nextFloat() + 0.32800000000000001D));
-                    double d2 = (double)field_881_b.nextFloat() * 2D * 3.1415899999999999D;
-                    int k1 = MathHelper.floor_double(d1 * java.lang.Math.sin(d2) + (double)basePos[0] + d);
-                    int l1 = MathHelper.floor_double(d1 * java.lang.Math.cos(d2) + (double)basePos[2] + d);
+                    double d1 = widthScale * ((double)treeShape * ((double) random.nextFloat() + 0.32800000000000001D));
+                    double d2 = (double) random.nextFloat() * 2D * 3.1415899999999999D;
+                    int k1 = MathHelper.floor(d1 * Math.sin(d2) + (double) origin[0] + d);
+                    int l1 = MathHelper.floor(d1 * Math.cos(d2) + (double) origin[2] + d);
                     int ai1[] = {
                             k1, j, l1
                     };
                     int ai2[] = {
-                            k1, j + field_869_n, l1
+                            k1, j + foliageHeight, l1
                     };
-                    if(func_524_a(ai1, ai2) != -1)
+                    if(checkLine(ai1, ai2) != -1)
                     {
                         continue;
                     }
                     int ai3[] = {
-                            basePos[0], basePos[1], basePos[2]
+                            origin[0], origin[1], origin[2]
                     };
-                    double d3 = java.lang.Math.sqrt(java.lang.Math.pow(java.lang.Math.abs(basePos[0] - ai1[0]), 2D) + java.lang.Math.pow(java.lang.Math.abs(basePos[2] - ai1[2]), 2D));
-                    double d4 = d3 * field_874_i;
+                    double d3 = Math.sqrt(Math.pow(Math.abs(origin[0] - ai1[0]), 2D) + Math.pow(Math.abs(origin[2] - ai1[2]), 2D));
+                    double d4 = d3 * branchSlop;
                     if((double)ai1[1] - d4 > (double)l)
                     {
                         ai3[1] = l;
@@ -91,7 +107,7 @@ public class WorldFeatureTreeEucalyptus extends WorldFeature
                     {
                         ai3[1] = (int)((double)ai1[1] - d4);
                     }
-                    if(func_524_a(ai3, ai1) == -1)
+                    if(checkLine(ai3, ai1) == -1)
                     {
                         ai[k][0] = k1;
                         ai[k][1] = j;
@@ -105,15 +121,15 @@ public class WorldFeatureTreeEucalyptus extends WorldFeature
                 i1--;
             }
         }
-        field_868_o = new int[k][4];
-        System.arraycopy(ai, 0, field_868_o, 0, k);
+        foliageCoords = new int[k][4];
+        System.arraycopy(ai, 0, foliageCoords, 0, k);
     }
 
-    void placeLeaves(int i, int j, int k, float f, byte byte0, int l)
+    void crossSection(int i, int j, int k, float f, byte byte0, int l)
     {
         int i1 = (int)((double)f + 0.61799999999999999D);
-        byte byte1 = field_882_a[byte0];
-        byte byte2 = field_882_a[byte0 + 3];
+        byte byte1 = axisConversionArray[byte0];
+        byte byte2 = axisConversionArray[byte0 + 3];
         int[] ai = {
                 i, j, k
         };
@@ -128,20 +144,20 @@ public class WorldFeatureTreeEucalyptus extends WorldFeature
             ai1[byte1] = ai[byte1] + j1;
             for(int l1 = -i1; l1 <= i1;)
             {
-                double d = java.lang.Math.sqrt(java.lang.Math.pow((double) java.lang.Math.abs(j1) + 0.5D, 4D) + java.lang.Math.pow((double) java.lang.Math.abs(l1) + 0.5D, 4D));
+                double d = Math.sqrt(Math.pow((double) Math.abs(j1) + 0.5D, 4D) + Math.pow((double) Math.abs(l1) + 0.5D, 4D));
                 if(d > (double)f)
                 {
                     l1++;
                 } else
                 {
                     ai1[byte2] = ai[byte2] + l1;
-                    int i2 = worldObj.getBlockId(ai1[0], ai1[1], ai1[2]);
+                    int i2 = world.getBlockId(ai1[0], ai1[1], ai1[2]);
                     if(i2 != 0 && i2 != leavesID)
                     {
                         l1++;
                     } else
                     {
-                        worldObj.setBlockWithNotify(ai1[0], ai1[1], ai1[2], l);
+                        world.setBlockWithNotify(ai1[0], ai1[1], ai1[2], l);
                         l1++;
                     }
                 }
@@ -151,64 +167,63 @@ public class WorldFeatureTreeEucalyptus extends WorldFeature
 
     }
 
-    float func_528_a(int i)
+    float treeShape(int i)
     {
-        if((double)i < (double)(float)field_878_e * 0.29999999999999999D)
+        if((double)i < (double)(float) height * 0.3D)
         {
             return -1.618F;
         }
-        float f = (float)field_878_e / 2.0F;
-        float f1 = (float)field_878_e / 2.0F - (float)i;
+        float f = (float) height / 2.0F;
+        float f1 = (float) height / 2.0F - (float)i;
         float f2;
         if(f1 == 0.0F)
         {
             f2 = f;
         } else
-        if(java.lang.Math.abs(f1) >= f)
+        if(Math.abs(f1) >= f)
         {
             f2 = 0.0F;
         } else
         {
-            f2 = (float) java.lang.Math.sqrt(java.lang.Math.pow(java.lang.Math.abs(f), 2D) - java.lang.Math.pow(java.lang.Math.abs(f1), 2D));
+            f2 = (float) Math.sqrt(Math.pow(Math.abs(f), 2D) - Math.pow(Math.abs(f1), 2D));
         }
         f2 *= 0.5F;
         return f2;
     }
 
-    float func_526_b(int i)
+    float foliageShape(int i)
     {
-        if(i < 0 || i >= field_869_n)
+        if(i < 0 || i >= foliageHeight)
         {
             return -1F;
         }
-        return i != 0 && i != field_869_n - 1 ? 3F : 2.0F;
+        return i != 0 && i != foliageHeight - 1 ? 3F : 2.0F;
     }
 
-    void func_520_a(int i, int j, int k)
+    void foliageCluster(int x, int y, int z)
     {
-        int l = j;
-        for(int i1 = j + field_869_n; l < i1; l++)
+        int l = y;
+        for(int i1 = y + foliageHeight; l < i1; l++)
         {
-            float f = func_526_b(l - j);
-            placeLeaves(i, l, k, f, (byte)1, leavesID);
+            crossSection(x, l, z, foliageShape(l - y), (byte)1, leavesID);
         }
 
     }
 
-    void func_518_b()
+    void makeFoliage()
     {
         int i = 0;
-        for(int j = field_868_o.length; i < j; i++)
+        for(int j = foliageCoords.length; i < j; i++)
         {
-            int k = field_868_o[i][0];
-            int l = field_868_o[i][1];
-            int i1 = field_868_o[i][2];
-            func_520_a(k, l, i1);
+            int x = foliageCoords[i][0];
+            int y = foliageCoords[i][1];
+            int z = foliageCoords[i][2];
+            foliageCluster(x, y, z);
         }
 
     }
 
-    void placeWood(int ai[], int ai1[], int i)
+    void limb(int ai[], int ai1[], int i)
     {
         int ai2[] = {
                 0, 0, 0
@@ -218,7 +233,7 @@ public class WorldFeatureTreeEucalyptus extends WorldFeature
         for(; byte0 < 3; byte0++)
         {
             ai2[byte0] = ai1[byte0] - ai[byte0];
-            if(java.lang.Math.abs(ai2[byte0]) > java.lang.Math.abs(ai2[j]))
+            if(Math.abs(ai2[byte0]) > Math.abs(ai2[j]))
             {
                 j = byte0;
             }
@@ -228,8 +243,8 @@ public class WorldFeatureTreeEucalyptus extends WorldFeature
         {
             return;
         }
-        byte byte1 = field_882_a[j];
-        byte byte2 = field_882_a[j + 3];
+        byte byte1 = axisConversionArray[j];
+        byte byte2 = axisConversionArray[j + 3];
         byte byte3;
         if(ai2[j] > 0)
         {
@@ -246,80 +261,70 @@ public class WorldFeatureTreeEucalyptus extends WorldFeature
         int k = 0;
         for(int l = ai2[j] + byte3; k != l; k += byte3)
         {
-            ai3[j] = MathHelper.floor_double((double)(ai[j] + k) + 0.5D);
-            ai3[byte1] = MathHelper.floor_double((double)ai[byte1] + (double)k * d + 0.5D);
-            ai3[byte2] = MathHelper.floor_double((double)ai[byte2] + (double)k * d1 + 0.5D);
-            worldObj.setBlockWithNotify(ai3[0], ai3[1], ai3[2], i);
+            ai3[j] = MathHelper.floor((double)(ai[j] + k) + 0.5D);
+            ai3[byte1] = MathHelper.floor((double)ai[byte1] + (double)k * d + 0.5D);
+            ai3[byte2] = MathHelper.floor((double)ai[byte2] + (double)k * d1 + 0.5D);
+            world.setBlockWithNotify(ai3[0], ai3[1], ai3[2], i);
         }
 
     }
 
-    boolean func_527_c(int i)
+    boolean trimBranches(int i)
     {
-        return (double)i >= (double)field_878_e * 0.20000000000000001D;
+        return (double)i >= (double) height * 0.2D;
     }
 
-    void func_529_c()
+    void makeTrunk()
     {
-        int i = basePos[0];
-        int j = basePos[1];
-        int k = basePos[1] + height;
-        int l = basePos[2];
-        int ai[] = {
-                i, j, l
-        };
-        int ai1[] = {
-                i, k, l
-        };
-        placeWood(ai, ai1, logID);
-        if(field_871_l == 2)
-        {
-            ai[0]++;
-            ai1[0]++;
-            placeWood(ai, ai1, logID);
-            ai[2]++;
-            ai1[2]++;
-            placeWood(ai, ai1, logID);
-            ai[0]--;
-            ai1[0]--;
-            placeWood(ai, ai1, logID);
+        int x = origin[0];
+        int y = origin[1];
+        int yTop = origin[1] + trunkHeight;
+        int z = origin[2];
+        int[] posBottom = { x, y, z };
+        int[] posTop = { x, yTop, z };
+        limb(posBottom, posTop, logID);
+        if(trunkWidth == 2)
+        {
+            posBottom[0]++;
+            posTop[0]++;
+            limb(posBottom, posTop, logID);
+            posBottom[2]++;
+            posTop[2]++;
+            limb(posBottom, posTop, logID);
+            posBottom[0]--;
+            posTop[0]--;
+            limb(posBottom, posTop, logID);
         }
     }
 
-    void func_525_d()
+    void makeBranches()
     {
         int i = 0;
-        int j = field_868_o.length;
-        int ai[] = {
-                basePos[0], basePos[1], basePos[2]
-        };
+        int j = foliageCoords.length;
+        int[] ai = { origin[0], origin[1], origin[2] };
         for(; i < j; i++)
         {
-            int ai1[] = field_868_o[i];
-            int ai2[] = {
-                    ai1[0], ai1[1], ai1[2]
-            };
+            int[] ai1 = foliageCoords[i];
+            int[] ai2 = { ai1[0], ai1[1], ai1[2] };
             ai[1] = ai1[3];
-            int k = ai[1] - basePos[1];
-            if(func_527_c(k))
+            int k = ai[1] - origin[1];
+            if(trimBranches(k))
             {
-                placeWood(ai, ai2, logID);
+                limb(ai, ai2, logID);
             }
         }
 
     }
 
-    int func_524_a(int ai[], int ai1[])
+    int checkLine(int ai[], int ai1[])
     {
-        int ai2[] = {
-                0, 0, 0
-        };
+        int[] ai2 = { 0, 0, 0 };
         byte byte0 = 0;
         int i = 0;
         for(; byte0 < 3; byte0++)
         {
             ai2[byte0] = ai1[byte0] - ai[byte0];
-            if(java.lang.Math.abs(ai2[byte0]) > java.lang.Math.abs(ai2[i]))
+            if(Math.abs(ai2[byte0]) > Math.abs(ai2[i]))
             {
                 i = byte0;
             }
@@ -329,8 +334,8 @@ public class WorldFeatureTreeEucalyptus extends WorldFeature
         {
             return -1;
         }
-        byte byte1 = field_882_a[i];
-        byte byte2 = field_882_a[i + 3];
+        byte byte1 = axisConversionArray[i];
+        byte byte2 = axisConversionArray[i + 3];
         byte byte3;
         if(ai2[i] > 0)
         {
@@ -353,9 +358,9 @@ public class WorldFeatureTreeEucalyptus extends WorldFeature
                 break;
             }
             ai3[i] = ai[i] + j;
-            ai3[byte1] = MathHelper.floor_double((double)ai[byte1] + (double)j * d);
-            ai3[byte2] = MathHelper.floor_double((double)ai[byte2] + (double)j * d1);
-            int l = worldObj.getBlockId(ai3[0], ai3[1], ai3[2]);
+            ai3[byte1] = MathHelper.floor((double)ai[byte1] + (double)j * d);
+            ai3[byte2] = MathHelper.floor((double)ai[byte2] + (double)j * d1);
+            int l = world.getBlockId(ai3[0], ai3[1], ai3[2]);
             if(l != 0 && l != leavesID)
             {
                 break;
@@ -367,24 +372,24 @@ public class WorldFeatureTreeEucalyptus extends WorldFeature
             return -1;
         } else
         {
-            return java.lang.Math.abs(j);
+            return Math.abs(j);
         }
     }
 
-    boolean func_519_e()
+    boolean checkLocation()
     {
         int ai[] = {
-                basePos[0], basePos[1], basePos[2]
+                origin[0], origin[1], origin[2]
         };
         int ai1[] = {
-                basePos[0], (basePos[1] + field_878_e) - 1, basePos[2]
+                origin[0], (origin[1] + height) - 1, origin[2]
         };
-        int idBelow = worldObj.getBlockId(basePos[0], basePos[1] - 1, basePos[2]);
+        int idBelow = world.getBlockId(origin[0], origin[1] - 1, origin[2]);
         if(!Block.hasTag(idBelow, BlockTags.GROWS_TREES))
         {
             return false;
         }
-        int j = func_524_a(ai, ai1);
+        int j = checkLine(ai, ai1);
         if(j == -1)
         {
             return true;
@@ -394,68 +399,53 @@ public class WorldFeatureTreeEucalyptus extends WorldFeature
             return false;
         } else
         {
-            field_878_e = j;
+            height = j;
             return true;
         }
     }
 
     @Override
-	public void func_517_a(double d, double d1, double d2)
+	public void init(double d, double d1, double d2)
     {
-        field_870_m = (int)(d * 20D);
+        heightVariance = (int)(d * 20D);
         if(d > 0.5D)
         {
-            field_869_n = 5;
+            foliageHeight = 5;
         }
-        field_873_j = d1;
-        field_872_k = d2;
+        widthScale = d1;
+        foliageDensity = d2;
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
-        worldObj = world;
+        this.world = world;
         long l = random.nextLong();
-        field_881_b.setSeed(l);
-        basePos[0] = x;
-        basePos[1] = y;
-        basePos[2] = z;
-        if(field_878_e == 0)
+        this.random.setSeed(l);
+        origin[0] = x;
+        origin[1] = y;
+        origin[2] = z;
+        if(height == 0)
         {
-            field_878_e = 12 + field_881_b.nextInt(4);
+            height = 12 + this.random.nextInt(4);
         }
-        if(!func_519_e())
+        if(!checkLocation())
         {
             return false;
         } else
         {
-            WorldFeatureTree.onTreeGrown(worldObj, basePos[0], basePos[1], basePos[2]);
-            func_521_a();
-            func_518_b();
-            func_529_c();
-            func_525_d();
+            WorldFeatureTree.onTreeGrown(this.world, origin[0], origin[1], origin[2]);
+            prepare();
+            makeFoliage();
+            makeTrunk();
+            makeBranches();
             return true;
         }
     }
 
-    static final byte field_882_a[] = {
+    static final byte[] axisConversionArray = {
             2, 0, 0, 1, 2, 1
     };
-    Random field_881_b;
-    World worldObj;
-    int basePos[] = {
-            0, 0, 0
-    };
-    int field_878_e;
-    int height;
-    double field_876_g;
-    double field_875_h;
-    double field_874_i;
-    double field_873_j;
-    double field_872_k;
-    int field_871_l;
-    int field_870_m;
-    int field_869_n;
-    int field_868_o[][];
+
 
 }
